/*
 * Copyright 2012 Adrian Toncean
 * 
 * This file is part of From Under the Rock.
 *
 * From Under the Rock is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * From Under the Rock is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with From Under the Rock. If not, see <http://www.gnu.org/licenses/>.
 */

package ds
import org.lwjgl.opengl.GL11

class Bush {
 var handle = 0
 assemble
 
 def assemble = {
  handle = GL11.glGenLists(1)
  GL11.glNewList(handle,GL11.GL_COMPILE)
  GL11.glBegin(GL11.GL_LINES)
   
  GL11.glVertex3d(0,-40,0); GL11.glVertex3d(0,-20,0);
  rec(14,0,-20,0,math.Pi/2d,1.4,8)
  
  GL11.glEnd
  GL11.glEndList
  DSManager.add(handle)
 }
 
 def rec(n: Int, x:Double, y:Double, z: Double, a: Double, b: Double, l:Double): Unit = {
   if(n > 0) {
     
     val na1 = a + (b + math.random * 0.3)
     val na2 = a - (b + math.random * 0.3)
     
     val nx1 = x + math.cos(na1)*l
     val ny1 = y + math.sin(na1)*l
     val nz1 = z + (math.random-0.5)*0.8*l
     
     val nx2 = x + math.cos(na2)*l;
     val ny2 = y + math.sin(na2)*l;
     val nz2 = z + (math.random-0.5)*0.8*l
     
     GL11.glVertex3d(x, y, z); GL11.glVertex3d(nx1,ny1,nz1)
     GL11.glVertex3d(x, y, z); GL11.glVertex3d(nx2,ny2,nz2)
     
     rec(n-1,nx1,ny1,nz1,na1,b*0.8,l*0.7)
     rec(n-2,nx2,ny2,nz2,na2,b*0.8,l*0.6)
   }
 }
  
 def call = {
  GL11.glCallList(handle);
 }
}