/*
 * Copyright 2012 Adrian Toncean
 * 
 * This file is part of From Under the Rock.
 *
 * From Under the Rock is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * From Under the Rock is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with From Under the Rock. If not, see <http://www.gnu.org/licenses/>.
 */

package ds
import org.lwjgl.opengl.GL11

class Cog(id:Double, in:Int) {
 var handle = 0
 val d = id
 val n = in
 val lat = 1
 assemble
 
 def assemble() = {
  handle = GL11.glGenLists(1);
  GL11.glNewList(handle,GL11.GL_COMPILE)
  
  GL11.glBegin(GL11.GL_LINES);
  
  val ka = math.Pi*2 / n
  var k = 0d
  val d_o = d+0.8
  val d_i = d-0.8
  
  for(i <- 1 to n) {
    val x0 = math.cos(k) * d_i
    val y0 = math.sin(k) * d_i
    k += ka/2
    val x1 = math.cos(k) * d_o
    val y1 = math.sin(k) * d_o
    k += ka/2
    val x2 = math.cos(k) * d_i
    val y2 = math.sin(k) * d_i
    
    GL11.glVertex3d(x0,-lat,y0); GL11.glVertex3d(x1,-lat,y1)
    GL11.glVertex3d(x1,-lat,y1); GL11.glVertex3d(x2,-lat,y2)
    
    GL11.glVertex3d(x0,-lat,y0); GL11.glVertex3d(x0, lat,y0)
    GL11.glVertex3d(x1,-lat,y1); GL11.glVertex3d(x1, lat,y1)
    
    GL11.glVertex3d(x0, lat,y0); GL11.glVertex3d(x1, lat,y1)
    GL11.glVertex3d(x1, lat,y1); GL11.glVertex3d(x2, lat,y2)
  }
  
  k = 0
  val ka2 = math.Pi*2 / 10
  for(i <- 1 to 10) {
    val x0 = math.cos(k) * 1
    val y0 = math.sin(k) * 1
    k += ka2
    val x1 = math.cos(k) * 1
    val y1 = math.sin(k) * 1
    
    GL11.glVertex3d(x0,-lat,y0); GL11.glVertex3d(x1,-lat,y1)
    
    GL11.glVertex3d(x0,-lat,y0); GL11.glVertex3d(x0, lat,y0)
    
    GL11.glVertex3d(x0, lat,y0); GL11.glVertex3d(x1, lat,y1)
  }
   
  GL11.glEnd();
  
  GL11.glEndList();
  
  DSManager.add(handle)
 }
  
 def call = {
  GL11.glCallList(handle);
 }
}