/*
 * Copyright 2012 Adrian Toncean
 * 
 * This file is part of From Under the Rock.
 *
 * From Under the Rock is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * From Under the Rock is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with From Under the Rock. If not, see <http://www.gnu.org/licenses/>.
 */

package ds
import org.lwjgl.opengl.GL11

object Coral {
 var handle = 0
 val nx = 4
 val ny = 4
 assemble
 
 def box = {
  GL11.glBegin(GL11.GL_LINES)
  
  GL11.glVertex3d(-1,  0,  1); GL11.glVertex3d( 1,  0,  1)
  GL11.glVertex3d( 1,  0,  1); GL11.glVertex3d( 1,  1,  1)
  GL11.glVertex3d( 1,  1,  1); GL11.glVertex3d(-1,  1,  1)
  GL11.glVertex3d(-1,  1,  1); GL11.glVertex3d(-1,  0,  1)
  
  GL11.glVertex3d(-1,  0, -1); GL11.glVertex3d( 1,  0, -1)
  GL11.glVertex3d( 1,  0, -1); GL11.glVertex3d( 1,  1, -1)
  GL11.glVertex3d( 1,  1, -1); GL11.glVertex3d(-1,  1, -1)
  GL11.glVertex3d(-1,  1, -1); GL11.glVertex3d(-1,  0, -1)
  
  GL11.glVertex3d(-1,  0, -1); GL11.glVertex3d(-1,  0,  1)
  GL11.glVertex3d( 1,  0, -1); GL11.glVertex3d( 1,  0,  1)
  GL11.glVertex3d( 1,  1, -1); GL11.glVertex3d( 1,  1,  1)
  GL11.glVertex3d(-1,  1, -1); GL11.glVertex3d(-1,  1,  1)
  
  GL11.glEnd
 }
 
 def assemble = {
  handle = GL11.glGenLists(1)
  GL11.glNewList(handle,GL11.GL_COMPILE)
  
  GL11.glPushMatrix
  GL11.glTranslated(-nx*2,-ny*2,0)
  for(i <- -nx to nx) {
    GL11.glPushMatrix
    for(i <- -ny to ny) {
      GL11.glPushMatrix
      if(math.random<0.3) GL11.glScaled(0.4,math.random*35+10,0.4)
      else GL11.glScaled(0.4,math.random*5+5,0.4)
      box
      GL11.glPopMatrix
      GL11.glTranslated(0,0,2)
    }
    GL11.glPopMatrix
    GL11.glTranslated(2,0,0)
  }
  GL11.glPopMatrix
  
  GL11.glEndList
  DSManager.add(handle)
 }
  
 def call = {
   GL11.glCallList(handle)
 }
}