/*
 * Copyright 2012 Adrian Toncean
 * 
 * This file is part of From Under the Rock.
 *
 * From Under the Rock is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * From Under the Rock is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with From Under the Rock. If not, see <http://www.gnu.org/licenses/>.
 */

package ds
import org.lwjgl.opengl.GL11

object Cube {
 var handle:Int = 0
 
 def assemble() = {
  handle = GL11.glGenLists(1);
  GL11.glNewList(handle,GL11.GL_COMPILE);

  //GL11.glColor3f(0.4f, 0.4f, 0.4f);
  
  GL11.glBegin(GL11.GL_QUADS);
  
  // Front Face
  
   GL11.glVertex3f(-1, -1,  1);  // Bottom Left Of The Texture and Quad
   GL11.glVertex3f( 1, -1,  1);  // Bottom Right Of The Texture and Quad
   GL11.glVertex3f( 1,  1,  1);  // Top Right Of The Texture and Quad
   GL11.glVertex3f(-1,  1,  1);  // Top Left Of The Texture and Quad

  // Back Face

   GL11.glVertex3f(-1, -1, -1);  // Bottom Right Of The Texture and Quad
   GL11.glVertex3f(-1,  1, -1);  // Top Right Of The Texture and Quad
   GL11.glVertex3f( 1,  1, -1);  // Top Left Of The Texture and Quad
   GL11.glVertex3f( 1, -1, -1);  // Bottom Left Of The Texture and Quad

  // Top Face

   GL11.glVertex3f(-1,  1, -1);  // Top Left Of The Texture and Quad
   GL11.glVertex3f(-1,  1,  1);  // Bottom Left Of The Texture and Quad
   GL11.glVertex3f( 1,  1,  1);  // Bottom Right Of The Texture and Quad
   GL11.glVertex3f( 1,  1, -1);  // Top Right Of The Texture and Quad

  // Bottom Face

   GL11.glVertex3f(-1, -1, -1);  // Top Right Of The Texture and Quad
   GL11.glVertex3f( 1, -1, -1);  // Top Left Of The Texture and Quad
   GL11.glVertex3f( 1, -1,  1);  // Bottom Left Of The Texture and Quad
   GL11.glVertex3f(-1, -1,  1);  // Bottom Right Of The Texture and Quad

  // Right face

   GL11.glVertex3f( 1, -1, -1);  // Bottom Right Of The Texture and Quad
   GL11.glVertex3f( 1,  1, -1);  // Top Right Of The Texture and Quad
   GL11.glVertex3f( 1,  1,  1);  // Top Left Of The Texture and Quad
   GL11.glVertex3f( 1, -1,  1);  // Bottom Left Of The Texture and Quad

  // Left Face

   GL11.glVertex3f(-1, -1, -1);  // Bottom Left Of The Texture and Quad
   GL11.glVertex3f(-1, -1,  1);  // Bottom Right Of The Texture and Quad
   GL11.glVertex3f(-1,  1,  1);  // Top Right Of The Texture and Quad
   GL11.glVertex3f(-1,  1, -1);  // Top Left Of The Texture and Quad
  
  GL11.glEnd(); 
  
  GL11.glEndList();
  
  DSManager.add(handle)
 }
 
 def call = {
  GL11.glCallList(handle);
 }
}