/*
 * Copyright 2012 Adrian Toncean
 * 
 * This file is part of From Under the Rock.
 *
 * From Under the Rock is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * From Under the Rock is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with From Under the Rock. If not, see <http://www.gnu.org/licenses/>.
 */

package ds
import org.lwjgl.opengl.GL11

class Disk(ior:Double, iir:Double, in:Int) {
 var handle = 0
 val or = ior
 val ir = iir
 val n = in
 assemble
 
 def assemble() = {
  handle = GL11.glGenLists(1);
  GL11.glNewList(handle,GL11.GL_COMPILE)
  
  GL11.glBegin(GL11.GL_LINES);
  
  val kad = math.Pi*2 / (n*3)
  var kd = 0d
  
  for(i <- 1 to n*3) {
    val x0i = math.cos(kd) * ir
    val y0i = math.sin(kd) * ir
    val x0o = math.cos(kd) * or
    val y0o = math.sin(kd) * or
    kd += kad
    val x1i = math.cos(kd) * ir
    val y1i = math.sin(kd) * ir
    val x1o = math.cos(kd) * or
    val y1o = math.sin(kd) * or
    
    GL11.glVertex3d(x0i,0,y0i); GL11.glVertex3d(x1i,0,y1i)
    GL11.glVertex3d(x0o,0,y0o); GL11.glVertex3d(x1o,0,y1o)
  }
  
  val kas = math.Pi*2 / n
  var ks = 0d
  
  for(i <- 1 to n) {
    val x0i = math.cos(ks) * ir
    val y0i = math.sin(ks) * ir
    val x0o = math.cos(ks) * or
    val y0o = math.sin(ks) * or
    ks += kas
    
    GL11.glVertex3d(x0i,0,y0i); GL11.glVertex3d(x0o,0,y0o)
  }
   
  GL11.glEnd();
  
  GL11.glEndList();
  
  DSManager.add(handle)
 }
  
 def call = {
  GL11.glCallList(handle);
 }
}