/*
 * Copyright 2012 Adrian Toncean
 * 
 * This file is part of From Under the Rock.
 *
 * From Under the Rock is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * From Under the Rock is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with From Under the Rock. If not, see <http://www.gnu.org/licenses/>.
 */

package ds
import org.lwjgl.opengl.GL11

object Door {
 var handle = 0
 
 def cuboid(dx:Double, d:Double, n:Int) = {
   val sx = -dx*n/2d
   val ex =  dx*n/2d
   var x = sx
   for(i <- 0 to n) {
     GL11.glVertex3d(x,-d,-d); GL11.glVertex3d(x,-d, d)
     GL11.glVertex3d(x,-d, d); GL11.glVertex3d(x, d, d)
     GL11.glVertex3d(x, d, d); GL11.glVertex3d(x, d,-d)
     GL11.glVertex3d(x, d,-d); GL11.glVertex3d(x,-d,-d)
     x += dx
   }
   GL11.glVertex3d(sx,-d,-d); GL11.glVertex3d(ex,-d,-d)
   GL11.glVertex3d(sx,-d, d); GL11.glVertex3d(ex,-d, d)
   GL11.glVertex3d(sx, d, d); GL11.glVertex3d(ex, d, d)
   GL11.glVertex3d(sx, d,-d); GL11.glVertex3d(ex, d,-d)
 }
 
 def assemble = {
  handle = GL11.glGenLists(1)
  GL11.glNewList(handle,GL11.GL_COMPILE)

  GL11.glPushMatrix
  GL11.glBegin(GL11.GL_LINES)
  GL11.glTranslatef(0,10,0)
  cuboid(1.2,0.8,12)
  GL11.glEnd()
  GL11.glPopMatrix
  
  
  GL11.glPushMatrix
  GL11.glBegin(GL11.GL_LINES)
  GL11.glTranslatef( 5,0,0)
  GL11.glRotatef(90,0,0,1)
  cuboid(1,0.5,20)
  GL11.glEnd()
  GL11.glPopMatrix
  
  
  GL11.glPushMatrix
  GL11.glBegin(GL11.GL_LINES)
  GL11.glTranslatef(-5,0,0)
  GL11.glRotatef(90,0,0,1)
  cuboid(1,0.5,20)
  GL11.glEnd()
  GL11.glPopMatrix
  
  GL11.glEndList()
  DSManager.add(handle)
 }
  
 def call = {
  GL11.glCallList(handle)
 }
}