/*
 * Copyright 2012 Adrian Toncean
 * 
 * This file is part of From Under the Rock.
 *
 * From Under the Rock is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * From Under the Rock is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with From Under the Rock. If not, see <http://www.gnu.org/licenses/>.
 */

package ds
import org.lwjgl.opengl.GL11

class Oct {
 var handle = 0
 assemble
 
 def oct = {
   GL11.glBegin(GL11.GL_LINES)
   var k = math.Pi/8
   val ka = math.Pi/4
   
   for(i <- 1 to 8) {
     val x0 = math.cos(k) * 1
     val y0 = math.sin(k) * 1
     k += ka
     val x1 = math.cos(k) * 1
     val y1 = math.sin(k) * 1
    
     GL11.glVertex3d(x0,y0,0); GL11.glVertex3d(x1,y1,0)
   }
   GL11.glEnd
 }
 
 def assemble = {
  handle = GL11.glGenLists(1);
  GL11.glNewList(handle,GL11.GL_COMPILE)
  
  GL11.glPushMatrix
  for(i <- 1 to 64) {
    GL11.glPushMatrix
    GL11.glRotatef((math.random*5).toFloat,0,1,0)
    GL11.glScaled(i/3d+10,i/3d+10,i/3d+10)
    oct
    GL11.glPopMatrix
  }
  GL11.glPopMatrix
  
  GL11.glEndList();
  DSManager.add(handle)
 }
  
 def call = {
  GL11.glCallList(handle);
 }
}