/*
 * Copyright 2012 Adrian Toncean
 * 
 * This file is part of From Under the Rock.
 *
 * From Under the Rock is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * From Under the Rock is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with From Under the Rock. If not, see <http://www.gnu.org/licenses/>.
 */

package ds
import org.lwjgl.opengl.GL11

class Plant {
 var handle = 0
 assemble
 
 def assemble = {
  handle = GL11.glGenLists(1)
  GL11.glNewList(handle,GL11.GL_COMPILE)
  GL11.glBegin(GL11.GL_LINES)
  
  rec(6,0,-20,0,math.Pi/2d,0,1.2)
  
  GL11.glEnd
  GL11.glEndList
  DSManager.add(handle)
 }
 
 def rec(n: Int, x:Double, y:Double, z: Double, a: Double, b:Double, l:Double): Unit = {
   if(n > 0) {
     var la = a
     var lb = b
     var nx = x
     var ny = y
     var nz = z
     var ox = x
     var oy = y
     var oz = z
     var hc = false
     
     for(i <- 1 to n) {
      val tmp = (math.random*10+10).toInt
      val aa = if(math.random < 0.5) math.random*0.05+0.05 else -(math.random*0.05+0.05)
      val ba = if(math.random < 0.5) math.random*0.05+0.05 else -(math.random*0.05+0.05)
      for(j <- 1 to tmp) {
       ox = nx; oy = ny; oz = nz
       
       nx += math.cos(la)*l*math.sin(lb)
       ny += math.sin(la)*l
       nz += math.cos(la)*l*math.cos(lb)
      
       GL11.glVertex3d(ox,oy,oz); GL11.glVertex3d(nx,ny,nz)
       GL11.glVertex3d(ox,oy,oz); GL11.glVertex3d(nx+l*2,ny+l*2,nz+l*2)
     
       la += aa
       lb += ba
      }
      if(i>2) {
       if(math.random < 0.5 || !hc) { rec(n-1,nx,ny,nz,la,lb,l*0.8); hc = true }
       if(math.random < 0.1) { rec(n-1,nx,ny,nz,la,lb,l*0.8); hc = true }
      }
     }
   }
 }
  
 def call = {
  GL11.glCallList(handle);
 }
}