/*
 * Copyright 2012 Adrian Toncean
 * 
 * This file is part of From Under the Rock.
 *
 * From Under the Rock is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * From Under the Rock is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with From Under the Rock. If not, see <http://www.gnu.org/licenses/>.
 */

package ds
import org.lwjgl.opengl.GL11

class Sapling {
 var handle = 0
 assemble
 
 def assemble = {
  handle = GL11.glGenLists(1)
  GL11.glNewList(handle,GL11.GL_COMPILE)
  GL11.glBegin(GL11.GL_LINES)
   
  GL11.glVertex3d(0,-40,0); GL11.glVertex3d(0,-30,0);
  rec(7,0,-30,0,0,0,5)
  
  GL11.glEnd
  GL11.glEndList
  DSManager.add(handle)
 }
 
 def rec(n: Int, x:Double, y:Double, z: Double, a: Double, b: Double, l:Double): Unit = {
   if(n > 0) {
     
     val nx1 = x + math.cos(0)*l
     val ny1 = y + math.random + l
     val nz1 = z + math.sin(0)*l
     
     val nx2 = x + math.sin(2/3*math.Pi)*l
     val ny2 = y + math.random + l
     val nz2 = z + math.cos(2/3*math.Pi)*l
     
     val nx3 = x + math.cos(4/3*math.Pi)*l
     val ny3 = y + math.random + l
     val nz3 = z + math.sin(4/3*math.Pi)*l
     
     GL11.glVertex3d(x, y, z); GL11.glVertex3d(nx1,ny1,nz1)
     GL11.glVertex3d(x, y, z); GL11.glVertex3d(nx2,ny2,nz2)
     GL11.glVertex3d(x, y, z); GL11.glVertex3d(nx3,ny3,nz3)
     
     rec(n-1,nx1,ny1,nz1,0,0,l*0.6)
     rec(n-2,nx2,ny2,nz2,0,0,l*0.6)
     rec(n-3,nx3,ny3,nz3,0,0,l*0.6)
   }
 }
  
 def call = {
  GL11.glCallList(handle)
 }
}