/*
 * Copyright 2012 Adrian Toncean
 * 
 * This file is part of From Under the Rock.
 *
 * From Under the Rock is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * From Under the Rock is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with From Under the Rock. If not, see <http://www.gnu.org/licenses/>.
 */

package ds
import org.lwjgl.opengl.GL11

class Surf(f: (Double,Double) => Double, isx:Double, iex:Double, isy:Double, iey:Double, in:Int) {
 var handle = 0
 val sx = isx
 val sy = iex
 val ex = isy
 val ey = iey
 val n = in
 assemble
 
 def assemble() = {
  handle = GL11.glGenLists(1)
  GL11.glNewList(handle,GL11.GL_COMPILE)
  GL11.glBegin(GL11.GL_LINES)
 
  val px = (ex-sx) / n
  val py = (ey-sy) / n
  var x = sx
  var y = sy
 
  for(i <- 0 to n) {
   line(f, x,sy, x,ey,n)
   line(f,sx, y,ex, y,n)
   x += px
   y += py
  }
 
  GL11.glEnd()
  GL11.glEndList()
  DSManager.add(handle)
 }
 
 def line(f: (Double,Double) => Double, sx: Double, sy: Double, ex: Double, ey:Double, n: Int) = {
   val px = (ex-sx) / n
   val py = (ey-sy) / n
   var x = sx
   var y = sy
   
   for(i <- 1 to n) {
     GL11.glVertex3d(x,f(x,y),y); GL11.glVertex3d(x+px,f(x+px,y+py),y+py)
     x += px
     y += py
   }
 }
  
 def call = {
  GL11.glCallList(handle);
 }
}