/*
 * Copyright 2012 Adrian Toncean
 * 
 * This file is part of From Under the Rock.
 *
 * From Under the Rock is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * From Under the Rock is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with From Under the Rock. If not, see <http://www.gnu.org/licenses/>.
 */

package ds
import org.lwjgl.opengl.GL11

object Tiles {
 var handle = 0
 val dx = 10
 val dy = 10
 val ds = 0.1
 val ds2 = 0.4
 assemble
 
 def square() = {
   GL11.glBegin(GL11.GL_LINES)
   GL11.glVertex3d(-1+ds, 0, -1+ds); GL11.glVertex3d( 1-ds, 0, -1+ds)
   GL11.glVertex3d( 1-ds, 0, -1+ds); GL11.glVertex3d( 1-ds, 0,  1-ds)
   GL11.glVertex3d( 1-ds, 0,  1-ds); GL11.glVertex3d(-1+ds, 0,  1-ds)
   GL11.glVertex3d(-1+ds, 0,  1-ds); GL11.glVertex3d(-1+ds, 0, -1+ds)
   
   GL11.glVertex3d(-1+ds2, 0, -1+ds2); GL11.glVertex3d( 1-ds2, 0, -1+ds2)
   GL11.glVertex3d( 1-ds2, 0, -1+ds2); GL11.glVertex3d( 1-ds2, 0,  1-ds2)
   GL11.glVertex3d( 1-ds2, 0,  1-ds2); GL11.glVertex3d(-1+ds2, 0,  1-ds2)
   GL11.glVertex3d(-1+ds2, 0,  1-ds2); GL11.glVertex3d(-1+ds2, 0, -1+ds2)
   GL11.glEnd
 }
 
 def assemble = {
  handle = GL11.glGenLists(1);
  GL11.glNewList(handle,GL11.GL_COMPILE)
  
  GL11.glPushMatrix
  GL11.glTranslated(-dx*2,0,-dy*2)
  for(i <- -dx to dx) {
    GL11.glPushMatrix
    for(i <- -dx to dx) {
      if(math.random < 0.1) {
        GL11.glPushMatrix
        if(math.random < 0.3) GL11.glTranslated(0,-math.random*20-5,0)
        else GL11.glTranslated(0,-math.random*2-2,0)
        GL11.glRotatef((math.random*90).toFloat,1,0,0)
        GL11.glRotatef((math.random*90).toFloat,0,0,1)
        square
        GL11.glPopMatrix
      }
      else square
      GL11.glTranslated(0,0,2)
    }
    GL11.glPopMatrix
    GL11.glTranslated(2,0,0)
  }
  GL11.glPopMatrix
  
  GL11.glEndList
  DSManager.add(handle)
 }
  
 def call = {
  GL11.glCallList(handle);
 }
}