/*
 * Copyright 2012 Adrian Toncean
 * 
 * This file is part of From Under the Rock.
 *
 * From Under the Rock is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * From Under the Rock is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with From Under the Rock. If not, see <http://www.gnu.org/licenses/>.
 */

package pack
import org.newdawn.slick.openal.Audio
import org.lwjgl.openal.AL10
import org.newdawn.slick.openal.SoundStore
import org.newdawn.slick.openal.AudioLoader
import org.newdawn.slick.util.ResourceLoader

object Sounds {
 val n = 5
 var c_intid = 0
 var c_arid = 0
 var sound = new Array[Audio](n)
 
 def load = {
   for(i <- 0 to n-1)
     sound(i) = AudioLoader.getStreamingAudio("OGG", ResourceLoader.getResource("res/t"+(i+1)+".ogg"))
     //ResourceLoader.getResourceAsStream("res/snd"+i+".wav")
 }
 
 def start = {
   c_arid = 0
   c_intid = sound(c_arid).playAsMusic(1.0f, 1.0f,false)
 }
 
 def ranEx(v:Int) = {
   var tmp = (math.random*n).toInt
   while(tmp == v) tmp = (math.random*n).toInt
   tmp
 }
 
 def adv = {
   if(AL10.alGetSourcei(c_intid,AL10.AL_SOURCE_STATE) != AL10.AL_PLAYING) {
     c_arid = ranEx(c_arid)
     c_intid = sound(c_arid).playAsMusic(1.0f, 1.0f,false)
   }
   SoundStore.get().poll(0)
 }
}