/*
 * Copyright 2012 Adrian Toncean
 * 
 * This file is part of From Under the Rock.
 *
 * From Under the Rock is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * From Under the Rock is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with From Under the Rock. If not, see <http://www.gnu.org/licenses/>.
 */

package rooms
import org.lwjgl.opengl.GL11

class Fly(ipy:Double, irx: Double, irz: Double) {
 var k = math.random * math.Pi*2
 val ak = if(math.random < 0.5) math.random * 0.04 + 0.02 else -(math.random * 0.04 + 0.02)
 val rx = irx
 val rz = irz
 var px = 0d
 val py0 = ipy
 val py1 = ipy-0.2
 val py2 = ipy+0.2
 var pz = 0d
 var opx = 1d
 var opz = 1d
 
 def draw = {
   GL11.glBegin(GL11.GL_LINES)
   GL11.glVertex3d(px+(opx-px)*4,py0,pz+(opz-pz)*4); GL11.glVertex3d(px,py1,pz)
   GL11.glVertex3d(px+(opx-px)*4,py0,pz+(opz-pz)*4); GL11.glVertex3d(px,py2,pz)
   GL11.glEnd
 }
 
 def adv = {
   k += ak
   opx = px
   opz = pz
   px = math.sin(k) * rx
   pz = math.cos(k) * rz
 }
}