/*
 * Copyright 2012 Adrian Toncean
 * 
 * This file is part of From Under the Rock.
 *
 * From Under the Rock is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * From Under the Rock is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with From Under the Rock. If not, see <http://www.gnu.org/licenses/>.
 */

package rooms
import ds._
import org.lwjgl.opengl.GL11
import pack.Pos

abstract class Room(icol:Boolean) {
 val l = 40
 val p0 = new Pos( 0, 35,-l)
 val p1 = new Pos(-l, 35, 0)
 val p2 = new Pos( 0, 35, l)
 val p3 = new Pos( l, 35, 0)
 val p4 = new Pos( 0, 35, 0)
 
 var col = icol
 
 def draw = {
   GL11.glPushMatrix
   GL11.glScalef(40,40,40)
   Room.call
   GL11.glPopMatrix
   
   GL11.glPushMatrix
   GL11.glTranslatef(  0, -30,   0)
   GL11.glPushMatrix
   GL11.glTranslatef(  0, 0.1f,-38)
   Door.call
   GL11.glPopMatrix
   
   GL11.glPushMatrix
   GL11.glTranslatef(  0, 0.1f, 38)
   Door.call
   GL11.glPopMatrix
   
   GL11.glPushMatrix
   GL11.glTranslatef(-38, 0.1f,  0)
   GL11.glRotatef(90,0,1,0)
   Door.call
   GL11.glPopMatrix
   
   GL11.glPushMatrix
   GL11.glTranslatef( 38, 0.1f, 0)
   GL11.glRotatef(90,0,1,0)
   Door.call
   GL11.glPopMatrix
   GL11.glPopMatrix
   
   if(col) {
     GL11.glPushMatrix
     GL11.glTranslatef( 0, -37, 0)
     GL11.glScalef(0.2f,0.2f,0.2f)
     RedCube.call
     GL11.glColor3f(0, 0, 0)
     GL11.glPopMatrix
   }
   
   drawS
 }
 
 def drawS: Unit
 def adv: Unit
 
 def isAtDoor(p: Pos) = {
   p.dist(p0) < 5 ||
   p.dist(p1) < 5 ||
   p.dist(p2) < 5 ||
   p.dist(p3) < 5
 }
 
 def getNearestDoor(p: Pos) = {
   var min: Double = 10000
   var mini = -1
   var tmp: Double = 0
   
   tmp = p.dist(p0)
   if(tmp < min) { min = tmp; mini = 0 }
   
   tmp = p.dist(p1)
   if(tmp < min) { min = tmp; mini = 1 }
    
   tmp = p.dist(p2)
   if(tmp < min) { min = tmp; mini = 2 }
    
   tmp = p.dist(p3)
   if(tmp < min) { min = tmp; mini = 3 }
   
   mini
 }
 
 def checkItem(p: Pos): Boolean = {
   if(col) {
     if(p.dist(p4) < 4) {
       col = false
       true
     }
     else false
   }
   else false
 }
}