/*
 * Copyright 2012 Adrian Toncean
 * 
 * This file is part of From Under the Rock.
 *
 * From Under the Rock is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * From Under the Rock is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with From Under the Rock. If not, see <http://www.gnu.org/licenses/>.
 */

package rooms

import org.lwjgl.opengl.GL11
import ds._
import scala.collection.mutable.MutableList

class RoomForest2 extends Room(false) {
  var t: Double = 0
  var tree = new MutableList[BushAndPR] 
  create
  
  def create = {
    for(i <- 1 to 10)
      tree += new BushAndPR(new Bush, new PosAndRot((math.random-0.5)*60,(math.random-0.5)*60,(math.random-0.5)*180)) 
  }
  
  def drawS = {
    GL11.glPushMatrix
    
    for(b <- tree)
    {
      GL11.glPushMatrix
      GL11.glTranslated(b.p.x,0,b.p.y)
      GL11.glRotatef(b.p.k.toFloat,0,1,0)
      
      b.b.call
      
      GL11.glPopMatrix
    }
    GL11.glPopMatrix
  }
  
  def adv = {
    t += 0.3
  }
}

class BushAndPR(ib:Bush, ip:PosAndRot) {
  val b = ib
  val p = ip
}