/*
 * Copyright 2012 Adrian Toncean
 * 
 * This file is part of From Under the Rock.
 *
 * From Under the Rock is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * From Under the Rock is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with From Under the Rock. If not, see <http://www.gnu.org/licenses/>.
 */

package rooms

import org.lwjgl.opengl.GL11
import ds._
import scala.collection.mutable.MutableList

class RoomSnow1 extends Room(true) {
  var t: Double = 0
  var snow = new MutableList[Pos3] 
  create
  
  def create = {
    
    for(i <- 1 to 300) {
      val tmp = (math.random*8).toInt + 4
      snow += new Pos3((math.random-0.5)*76,(math.random-0.5)*76,(math.random-0.5)*76)
    }
  }
  
  def drawS = {
    GL11.glPushMatrix
    
    for(s <- snow)
    {
      GL11.glPushMatrix
      GL11.glTranslated(s.x,s.y,s.z)
      //GL11.glRotatef(math.random.toFloat*180,1,1,0)
      
      Snow.call
      
      GL11.glPopMatrix
    }
    GL11.glPopMatrix
  }
  
  def adv = {
    t += 0.3
    
    if(t > 200) t = 0
    if(t > 100) {
      for(s <- snow) {
        s.x += (math.random-0.5)
        s.y += (math.random-0.5)
        s.z += (math.random-0.5)
      }
    } 
    else {
     for(s <- snow) {
       s.y += 0.1
       if(s.y > 40) s.y = -41
     }
    }
  }
}